  GET	stm32f103C8.asm
  AREA __data, DATA, READWRITE
SYSTICK_COUNTER
  DCD  0

  AREA __utils,CODE,READONLY

SYSTICK_START   PROC
  PUSH	{R0, R1 ,LR}
  LDR   R0 , =SYSTICK_BASE
  LDR   R1 , =72000 - 1
  STR   R1 , [R0 , #STK_LOAD]
  LDR   R1, [R0 , #STK_VAL]
  BIC   R1, R1, #0x00FFFFFF
  STR   R1, [R0 , #STK_VAL]
  LDR   R0, =SCB_BASE
  LDR   R1, [R0, #SCB_SHPR3]
  ORR   R1, R1, #0xF0 << 24
  STR   R1, [R0, #SCB_SHPR3]

  LDR   R0, =SYSTICK_BASE
  LDR   R1, [R0 , #STK_CTRL]
  ORR   R1, R1, #(STK_CTRL_CLKSOURSE +  STK_CTRL_TICKINT + STK_CTRL_ENABLE)
  STR   R1, [R0 , #STK_CTRL]

  POP   {R0, R1 ,PC}
  ENDP


SYSTICK_DELAY   PROC
  PUSH	{R1, R2, LR}
  MOV   R1, #0
  LDR   R2, =SYSTICK_BASE
  STR   R0, [R2, #STK_VAL]
  LDR   R1, =SYSTICK_COUNTER
  STR   R0, [R1]
delay_loop1
  LDR   R0, [R1]
  ORRS  R0, R0, #0
  BNE   delay_loop1  
  POP   {R1, R2, PC}
  ENDP

ISR_SYSTICK     PROC
  LDR   R1, =SYSTICK_COUNTER
  LDR   R0, [R1]
  CMP   R0, #0
  ITT    NE
  SUBNE	R0, R0, #1
  STRNE	R0, [R1]
  BX    LR
  ENDP

  ALIGN

  EXPORT SYSTICK_START
  EXPORT ISR_SYSTICK
  EXPORT SYSTICK_DELAY

  END